blob: ffb928b9c74b1c540c8458138548e845299e4875 [file] [log] [blame]
Emese Revfy6b90bd42016-05-24 00:09:38 +02001ifdef CONFIG_GCC_PLUGINS
2 __PLUGINCC := $(call cc-ifversion, -ge, 0408, $(HOSTCXX), $(HOSTCC))
3 PLUGINCC := $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-plugin.sh "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)")
4
Emese Revfy543c37c2016-05-24 00:11:37 +02005 SANCOV_PLUGIN := -fplugin=$(objtree)/scripts/gcc-plugins/sancov_plugin.so
6
Emese Revfy0dae7762016-05-24 00:10:35 +02007 gcc-plugin-$(CONFIG_GCC_PLUGIN_CYC_COMPLEXITY) += cyc_complexity_plugin.so
Emese Revfy543c37c2016-05-24 00:11:37 +02008
9 ifdef CONFIG_GCC_PLUGIN_SANCOV
10 ifeq ($(CFLAGS_KCOV),)
11 # It is needed because of the gcc-plugin.sh and gcc version checks.
12 gcc-plugin-$(CONFIG_GCC_PLUGIN_SANCOV) += sancov_plugin.so
13
14 ifneq ($(PLUGINCC),)
15 CFLAGS_KCOV := $(SANCOV_PLUGIN)
16 else
17 $(warning warning: cannot use CONFIG_KCOV: -fsanitize-coverage=trace-pc is not supported by compiler)
18 endif
19 endif
20 endif
21
Emese Revfy65d59ec2016-06-20 20:40:24 +020022 GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fplugin=$(objtree)/scripts/gcc-plugins/, $(gcc-plugin-y)) $(gcc-plugin-cflags-y))
Emese Revfy6b90bd42016-05-24 00:09:38 +020023
Emese Revfy543c37c2016-05-24 00:11:37 +020024 export PLUGINCC GCC_PLUGINS_CFLAGS GCC_PLUGIN SANCOV_PLUGIN
Emese Revfy6b90bd42016-05-24 00:09:38 +020025
Kees Cooked58c0e2016-06-17 23:11:12 -070026 ifneq ($(PLUGINCC),)
Emese Revfy543c37c2016-05-24 00:11:37 +020027 # SANCOV_PLUGIN can be only in CFLAGS_KCOV because avoid duplication.
28 GCC_PLUGINS_CFLAGS := $(filter-out $(SANCOV_PLUGIN), $(GCC_PLUGINS_CFLAGS))
Emese Revfy6b90bd42016-05-24 00:09:38 +020029 endif
30
31 KBUILD_CFLAGS += $(GCC_PLUGINS_CFLAGS)
32 GCC_PLUGIN := $(gcc-plugin-y)
Emese Revfy6b90bd42016-05-24 00:09:38 +020033endif
Kees Cooked58c0e2016-06-17 23:11:12 -070034
35# If plugins aren't supported, abort the build before hard-to-read compiler
36# errors start getting spewed by the main build.
37PHONY += gcc-plugins-check
38gcc-plugins-check: FORCE
39ifdef CONFIG_GCC_PLUGINS
40 ifeq ($(PLUGINCC),)
41 ifneq ($(GCC_PLUGINS_CFLAGS),)
42 ifeq ($(call cc-ifversion, -ge, 0405, y), y)
43 $(Q)$(srctree)/scripts/gcc-plugin.sh --show-error "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)" || true
44 @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc installation does not support plugins, perhaps the necessary headers are missing?" >&2 && exit 1
45 else
46 @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc version does not support plugins, you should upgrade it to at least gcc 4.5" >&2 && exit 1
47 endif
48 endif
49 endif
50endif
51 @:
52
53# Actually do the build, if requested.
54PHONY += gcc-plugins
55gcc-plugins: scripts_basic gcc-plugins-check
56ifdef CONFIG_GCC_PLUGINS
57 $(Q)$(MAKE) $(build)=scripts/gcc-plugins
58endif
59 @: